## librcsb-core-wrapper 1.000

=== Makefile ===
# Top level Makefile

UTIL_LOC = https://svn-dev.wwpdb.org/svn-rcsb/build/util
UTIL_MODULE = util
CHECKOUT_SCRIPT = checkout.sh
DIFF_SCRIPT = diff.sh
COMPILE_SCRIPT = compile.sh
CLEAN_SCRIPT = clean.sh
TEST_SCRIPT = test.sh
CLEAN_TEST_SCRIPT = clean_test.sh
DOC_SCRIPT = doc.sh
CLEAN_DOC_SCRIPT = clean_doc.sh
EXPORT_SCRIPT = export.sh

all: 
	@echo
	@echo ------- compile targets are compile_lnx_38, compile_lnx_41, and compile_osx -------

compile:  
	@echo
	@echo ------- compile targets are compile_lnx_38, compile_lnx_41, and compile_osx -------

install: 
	@echo 
	@echo -------- Updating shared wrapper library --------
	@rm -f ./test/CorePyWrap.so
	@cp ./wrapper/lib/CorePyWrap.so ./test


build: checkout

clean: clean_build clean_test clean_doc

checkout:
	@echo 
	@echo -------- Getting version Latest of module util --------
	@svn co $(UTIL_LOC)/trunk $(UTIL_MODULE) 
	@sh -c 'cd ./$(UTIL_MODULE); ./$(CHECKOUT_SCRIPT)'

diff:
	@sh -c 'cd ./$(UTIL_MODULE); ./$(DIFF_SCRIPT)'

compile_osx:
	@sh -c 'cd ./$(UTIL_MODULE); \
         export PIC=-fPIC;  \
         export WWPDB_XERCESC_INC=/opt/local/include; \
         export WWPDB_XERCESC_LIB_DIR=/opt/local/lib; \
         export WWPDB_XERCESC_LIB=xerces-c-3.1; \
         export WWPDB_PYTHON_INC=/opt/local/Library/Frameworks/Python.framework/Versions/2.7/include/python2.7; \
         export WWPDB_BOOST_INC=/opt/local/include; \
         export WWPDB_BOOST_PYTHON_LIB_DIR=/opt/local/lib; \
         export WWPDB_BOOST_PYTHON_LIB=boost_python-mt; \
         export WWPDB_PYTHON_LIB_DIR=/opt/local/lib; \
         export WWPDB_PYTHON_LIB=python2.7; \
        ./$(COMPILE_SCRIPT)'

compile_lnx_38:
	@sh -c 'cd ./$(UTIL_MODULE); \
         export PIC=-fPIC;  \
         export WWPDB_PYTHON_INC=/apps/python/include/python2.5; \
         export WWPDB_PYTHON_LIB_DIR=/apps/python/lib; \
         export WWPDB_PYTHON_LIB=python2.5; \
         export WWPDB_BOOST_INC=/apps/boost_1_38_0/include/boost-1_38; \
         export WWPDB_BOOST_PYTHON_LIB_DIR=/apps/boost_1_38_0/lib; \
         export WWPDB_BOOST_PYTHON_LIB=boost_python-gcc41-mt-1_38; \
         export WWPDB_XERCESC_INC=/apps/xerces-3.0.1/include; \
         export WWPDB_XERCESC_LIB_DIR=/apps/xerces-3.0.1/lib; \
         export WWPDB_XERCESC_LIB=xerces-c; \
         ./$(COMPILE_SCRIPT)'

compile_lnx_41:
	@sh -c 'cd ./$(UTIL_MODULE); \
        export PIC=-fPIC; \
        export WWPDB_PYTHON_INC=/apps/python/include/python2.5; \
	export WWPDB_PYTHON_LIB_DIR=/apps/python/lib; \
        export WWPDB_PYTHON_LIB=python2.5; \
        export WWPDB_BOOST_INC=/apps/boost/include/boost-1_41; \
        export WWPDB_BOOST_PYTHON_LIB_DIR=/apps/boost/lib; \
        export WWPDB_BOOST_PYTHON_LIB=boost_python-gcc41-mt-1_41; \
        export WWPDB_XERCESC_INC=/apps/xerces-3.0.1/include; \
        export WWPDB_XERCESC_LIB_DIR=/apps/xerces-3.0.1/lib; \
        export WWPDB_XERCESC_LIB=xerces-c; \
        ./$(COMPILE_SCRIPT)'

debug:
	@sh -c 'cd ./$(UTIL_MODULE); ./$(COMPILE_SCRIPT) debug'

clean_build: 
	@sh -c 'cd ./$(UTIL_MODULE); ./$(CLEAN_SCRIPT)'

test: test-all

testall: compile 
	@sh -c 'cd ./$(UTIL_MODULE); ./$(TEST_SCRIPT)'

clean_test: 
	@sh -c 'cd ./$(UTIL_MODULE); ./$(CLEAN_TEST_SCRIPT)'

###
doc:
	@sh -c 'cd ./$(UTIL_MODULE); ./$(DOC_SCRIPT)'

clean_doc:
	@sh -c 'cd ./$(UTIL_MODULE); ./$(CLEAN_DOC_SCRIPT)'

export: clean
	@sh -c 'cd ./$(UTIL_MODULE); ./$(EXPORT_SCRIPT)'

###

everything:  compile

=== cctbx/Makefile ===
all:  install

install:
	@cp scitbx/boost_python/container_conversions.h ../include

clean_build:
	@rm -f ../include/container_conversions.h

clean_test:
	@test

=== wrapper/Makefile ===
#
#        WRAPPER module makefile
#
#----------------------------------------------------------------------------
# Project specific path defintions.
#----------------------------------------------------------------------------
M_INCL_DIR  = ../include
M_LIB_DIR   = ../lib

PROJ_DIR = .

L_INCL_DIR  = $(PROJ_DIR)/include
SRC_DIR     = $(PROJ_DIR)/src
OBJ_DIR     = $(PROJ_DIR)/obj
L_LIB_DIR   = $(PROJ_DIR)/lib

VPATH = $(OBJ_DIR)

EXT_COMP_OPT = -ftemplate-depth-128 -fno-inline -Wall

EXT_INCLS_DIRS = -I$(WWPDB_PYTHON_INC) -I$(WWPDB_BOOST_INC)
EXT_LIBS_DIRS = -L$(WWPDB_BOOST_PYTHON_LIB_DIR) -L$(WWPDB_XERCESC_LIB_DIR)
EXT_LIBS      = -l$(WWPDB_BOOST_PYTHON_LIB) -l$(WWPDB_XERCESC_LIB)

SYS_LIBS = -lutil -lpthread -ldl

LINK_METHOD = -shared

#----------------------------------------------------------------------------
# LINCLUDES and LDEFINES are appended to CFLAGS and C++FLAGS
#----------------------------------------------------------------------------
LDEFINES  = 
LINCLUDES = -I$(L_INCL_DIR) -I$(M_INCL_DIR) $(EXT_INCLS_DIRS)

#----------------------------------------------------------------------------
# Include the appropriate compiler/platform definitions ...
#----------------------------------------------------------------------------
include ../etc/Makefile.platform

# Dependent libraries
PDBML_PARSER_LIB  = ../$(M_LIB_DIR)/pdbml-parser.a
DICT_OBJ_FILE_LIB = ../$(M_LIB_DIR)/dict-obj-file.a
CIF_FILE_UTIL_LIB = ../$(M_LIB_DIR)/cif-file-util.a
CIF_FILE_LIB      = ../$(M_LIB_DIR)/cif-file.a
CIFPARSE_LIB      = ../$(M_LIB_DIR)/cifparse-obj.a
TABLES_LIB        = ../$(M_LIB_DIR)/tables.a
COMMON_LIB        = ../$(M_LIB_DIR)/common.a
REGEX_LIB         = ../$(M_LIB_DIR)/regex.a

ALL_DEP_LIBS = $(PDBML_PARSER_LIB) $(DICT_OBJ_FILE_LIB) $(CIF_FILE_UTIL_LIB) \
  $(CIF_FILE_LIB) $(CIFPARSE_LIB) $(TABLES_LIB) $(COMMON_LIB) $(REGEX_LIB)

# Module libraries
MOD_LIB = CorePyWrap.so

# Agregate library
AGR_LIB = all.a

# Temporary library. Used to obtain the agregate library.
TMP_LIB = tmp.a

L_MOD_LIB = $(L_LIB_DIR)/$(MOD_LIB)
M_MOD_LIB = $(M_LIB_DIR)/$(MOD_LIB)
L_AGR_LIB = $(L_LIB_DIR)/$(AGR_LIB)
M_AGR_LIB = $(M_LIB_DIR)/$(AGR_LIB)


# Base file names. Must have ".ext" at the end of the file.
BASE_REGULAR_FILES = TypeCodePyWrap.ext \
                     StlPyWrap.ext \
                     CharPyWrap.ext \
                     RcsbFilePyWrap.ext \
                     ISTablePyWrap.ext \
                     TableFilePyWrap.ext \
                     CifFilePyWrap.ext \
                     DicFilePyWrap.ext \
                     DictObjFilePyWrap.ext \
                     DataInfoPyWrap.ext \
                     CifDataInfoPyWrap.ext \
                     DictDataInfoPyWrap.ext \
                     PdbMlFilePyWrap.ext \
                     CorePyWrap.ext

BASE_FILES = $(BASE_REGULAR_FILES)

# Source files. Replace ".ext" with ".C"
SRC_FILES = ${BASE_FILES:.ext=.C}

# Object files. Replace ".ext" with ".o"
OBJ_FILES = ${BASE_FILES:.ext=.o}

# Base header files. Replace ".ext" with ".h"
BASE_HEADER_FILES = ${BASE_FILES:.ext=.h}

EXTRA_HEADER_FILES = 

HEADER_FILES = $(BASE_HEADER_FILES) $(EXTRA_HEADER_FILES)

ALL_OBJ_FILES = *.o

.PHONY: ../etc/Makefile.platform all install export clean clean_build


all: install


install: $(M_MOD_LIB)


export:
	mkdir -p $(EXPORT_DIR)
	@cp Makefile $(EXPORT_DIR)
	@cd $(EXPORT_DIR); mkdir -p $(L_INCL_DIR)
	@cd $(L_INCL_DIR); $(EXPORT) $(EXPORT_LIST) $(HEADER_FILES) ../$(EXPORT_DIR)/$(L_INCL_DIR)
	@cd $(EXPORT_DIR); mkdir -p $(SRC_DIR)
	@cd $(SRC_DIR);	$(EXPORT) $(EXPORT_LIST) $(SRC_FILES) ../$(EXPORT_DIR)/$(SRC_DIR)
	@cd $(EXPORT_DIR); mkdir -p $(OBJ_DIR)
	@cd $(EXPORT_DIR); mkdir -p $(L_LIB_DIR)


clean: clean_build


$(M_MOD_LIB): $(L_MOD_LIB)
#       Install module library
	$(INSTALL) $(INSTALLOPTS) $(L_MOD_LIB) $(PROJ_DIR)
	$(INSTALL) $(INSTALLOPTS) $(L_MOD_LIB) $(M_LIB_DIR)


clean_build:
	@rm -f $(OBJ_DIR)/*.o
	@rm -rf $(OBJ_DIR)/ii_files
	@rm -f $(L_MOD_LIB)
	@rm -f $(PROJ_DIR)/$(MOD_LIB)
	@rm -f $(M_MOD_LIB)
	@rm -f $(M_AGR_LIB)
	@rm -f *.pyc


$(L_MOD_LIB): $(OBJ_FILES) $(ALL_DEP_LIBS)
#       Create module library

	@cd $(OBJ_DIR); $(CCC) $(LINK_METHOD) $(EXT_LIBS_DIRS) $(OBJ_FILES) $(ALL_DEP_LIBS) $(EXT_LIBS) $(SYS_LIBS) -o ../$@


# Rule for making object files
%.o: $(SRC_DIR)/%.C
	$(CCC) $(C++FLAGS) $(EXT_COMP_OPT) -c $< -o $(OBJ_DIR)/$@

=== debian/changelog ===
librcsb-core-wrapper (1.000-3) unstable; urgency=low

  * Fixed make test "missing target" error (Closes: #724151).

 -- Laszlo Kajan <lkajan@rostlab.org>  Mon, 30 Sep 2013 19:41:17 +0200

librcsb-core-wrapper (1.000-2) unstable; urgency=low

  * Corrected to install rcsb/ dir into -dev package instead of include/ dir.
  * Patched upstream to not try to remove "/dev/null" log file.
  * Changed interpreter of wrapper/python/setup.py.in from
    #!/usr/bin/env python to #!/usr/bin/python

 -- Laszlo Kajan <lkajan@rostlab.org>  Wed, 19 Sep 2012 15:17:59 +0200

librcsb-core-wrapper (1.000-1) unstable; urgency=low

  [ Laszlo Kajan <lkajan@rostlab.org> ]
  * Initial release in Debian (Closes: #684403)

 -- Laszlo Kajan <lkajan@rostlab.org>  Fri, 10 Aug 2012 11:25:46 +0200

=== debian/control ===
Source: librcsb-core-wrapper
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders:
 Laszlo Kajan <lkajan@rostlab.org>
Build-Depends: debhelper (>= 7.3.5), doxygen, graphviz, libboost-python-dev, libxerces-c-dev,
 python-all-dev (>= 2.6.6-3~), python-all-dbg,
 libtool, bison, flex
Standards-Version: 3.9.4
Section: libs
Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/rcsb-core-wrapper/trunk
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/rcsb-core-wrapper/trunk/
Homepage: http://sw-tools.rcsb.org/apps/CORE-WRAPPER/index.html
X-Python-Version: >= 2.5

Package: librcsb-core-wrapper0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ library providing OO API to information in mmCIF format
 The RCSB Core Wrapper library was developed to provide an object-oriented
 application interface to information in mmCIF format. It includes several
 classes for accessing data dictionaries and mmCIF format data files.
 .
 This package contains the shared library.

Package: librcsb-core-wrapper0-dev
Section: libdevel
Architecture: any
Depends: librcsb-core-wrapper0 (= ${binary:Version}), ${misc:Depends},
Suggests: librcsb-core-wrapper0-dbg, librcsb-core-wrapper-doc
Provides: librcsb-core-wrapper-dev
Description: development files for librcsb-core-wrapper0
 The RCSB Core Wrapper library was developed to provide an object-oriented
 application interface to information in mmCIF format. It includes several
 classes for accessing data dictionaries and mmCIF format data files.
 .
 This package contains files necessary for developing applications with
 the library.

Package: librcsb-core-wrapper-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: documentation for librcsb-core-wrapper0
 The RCSB Core Wrapper library was developed to provide an object-oriented
 application interface to information in mmCIF format. It includes several
 classes for accessing data dictionaries and mmCIF format data files.
 .
 This package contains html documentation.

Package: librcsb-core-wrapper0-dbg
Architecture: any
Section: debug
Priority: extra
Depends: librcsb-core-wrapper0 (= ${binary:Version}), ${misc:Depends}
Enhances: librcsb-core-wrapper0-dev, python-corepywrap
Description: debugging symbols for librcsb-core-wrapper0
 The RCSB Core Wrapper library was developed to provide an object-oriented
 application interface to information in mmCIF format. It includes several
 classes for accessing data dictionaries and mmCIF format data files.
 .
 This package contains the detached debug symbols for the library and the
 Python bindings.
 
Package: python-corepywrap
Architecture: any
Section: python
Priority: extra
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, librcsb-core-wrapper0 (= ${binary:Version})
Suggests: librcsb-core-wrapper0-dbg, librcsb-core-wrapper-doc
Description: library that exports C++ mmCIF accessors to Python
 The RCSB Core Wrapper library was developed to provide an object-oriented
 application interface to information in mmCIF format. It includes several
 classes for accessing data dictionaries and mmCIF format data files.
 .
 This library provides Python bindings for librcsb-core-wrapper.
 
Package: python-corepywrap-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, librcsb-core-wrapper0 (= ${binary:Version}), python-dbg
Suggests: librcsb-core-wrapper0-dbg, librcsb-core-wrapper-doc
Description: library that exports C++ mmCIF accessors to Python (debug version)
 The RCSB Core Wrapper library was developed to provide an object-oriented
 application interface to information in mmCIF format. It includes several
 classes for accessing data dictionaries and mmCIF format data files.
 .
 This library provides Python bindings for librcsb-core-wrapper (debugging
 interpreter).

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND  = -Wl,--as-needed

export CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
export CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
export CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
export LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

# lkajan: we borrow from libtorrent-rasterbar and pythonmagick here (thank you)
PYVERSIONS=$(shell pyversions -vr)
# lkajan: the below could include debug versions like in python-libtorrent
ALLPY=$(PYVERSIONS) $(PYVERSIONS:%=%-dbg)

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --parallel --with python2

.PHONY: override_dh_auto_build
override_dh_auto_build: override_dh_auto_build-nopy override_dh_auto_build-py

.PHONY: override_dh_auto_build-nopy
override_dh_auto_build-nopy:
	dh_auto_build --parallel
	$(MAKE) doc

.PHONY: override_dh_auto_build-py
override_dh_auto_build-py: override_dh_auto_build-nopy
	dh_auto_build --parallel --sourcedirectory=wrapper/python

.PHONY: override_dh_auto_install
override_dh_auto_install: override_dh_auto_install-nopy override_dh_auto_install-py

.PHONY: override_dh_auto_install-nopy
override_dh_auto_install-nopy:
	# lkajan: there is no real install mechanism in the upstream sources

.PHONY: override_dh_auto_install-py
override_dh_auto_install-py:
	dh_auto_install --sourcedirectory=wrapper/python 

.PHONY: override_dh_strip
override_dh_strip:
	dh_strip --dbg-package=librcsb-core-wrapper0-dbg

.PHONY: override_dh_makeshlibs
override_dh_makeshlibs:
	dh_makeshlibs -V

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	dh_auto_clean
	rm -rf wrapper/python/build

.PHONY:
get-orig-source:
	mkdir -p ../tarballs
	uscan --verbose --force-download --destdir=../tarballs

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

http://sw-tools.rcsb.org/apps/CORE-WRAPPER/source/source.html core-wrapper-v([\d.]+)-prod-src\.tar\..z
